import { TypedRule } from '@fimbul/ymir';
export declare class Rule extends TypedRule {
    apply(): void;
    private maybePromiseLike;
    /**
     * A type is thenable when it has a callable `then` property.
     * We don't care if the signatures are actually callable because the compiler already complains about that.
     */
    private isThenable;
    private isAsyncIterable;
    /**
     * We consider a type as AsyncIterable when it has a property key [Symbol.asyncIterator].
     * The spec requires this property to be a function returning an object with a `next` method which returns a Promise of IteratorResult.
     * But that's none of our business as the compiler already does the heavy lifting.
     */
    private hasSymbolAsyncIterator;
    private isIterableOfPromises;
}
