"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ymir_1 = require("@fimbul/ymir");
const ts = require("typescript");
const tsutils_1 = require("tsutils");
let Rule = class Rule extends ymir_1.AbstractRule {
    apply() {
        let wrappedAst;
        const { text } = this.sourceFile;
        const re = /\bnew\b/g;
        for (let match = re.exec(text); match !== null; match = re.exec(text)) {
            const { node } = tsutils_1.getWrappedNodeAtPosition(wrappedAst || (wrappedAst = this.context.getWrappedAst()), match.index);
            if (node.kind === ts.SyntaxKind.NewExpression &&
                text[node.end - 1] !== ')' &&
                re.lastIndex === node.expression.pos)
                this.addFinding(node.end, node.end, 'Expected parentheses on constructor call.', ymir_1.Replacement.append(node.end, '()'));
        }
    }
};
Rule = tslib_1.__decorate([
    ymir_1.excludeDeclarationFiles
], Rule);
exports.Rule = Rule;
//# sourceMappingURL=new-parens.js.map