import { TypedRule } from '@fimbul/ymir';
export declare class Rule extends TypedRule {
    private checkType;
    apply(): void;
    /**
     * This function is necessary because higher order function type inference creates Signatures whose declaration has no type parameters.
     * @see https://github.com/Microsoft/TypeScript/issues/30296
     *
     * To work around this, we look for a single call signature on the called expression and use its type parameters instead.
     * As a bonus this also works for unified signatures from union types.
     */
    private getTypeParametersOfCallSignature;
    private mapTypeParameter;
    private checkCallExpression;
    private checkNewExpression;
    private checkInferredTypeParameters;
    private checkTypeArgument;
}
