"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ymir_1 = require("@fimbul/ymir");
const tsutils_1 = require("tsutils");
const ts = require("typescript");
let Rule = class Rule extends ymir_1.AbstractRule {
    apply() {
        for (const node of this.context.getFlatAst())
            if (node.kind === ts.SyntaxKind.ElementAccessExpression)
                this.checkElementAccess(node);
    }
    checkElementAccess(node) {
        if (!tsutils_1.isTextualLiteral(node.argumentExpression))
            return;
        const { text } = node.argumentExpression;
        if (!tsutils_1.isValidPropertyAccess(text))
            return;
        this.addFindingAtNode(node.argumentExpression, `Prefer 'obj.${text}' over 'obj[${node.argumentExpression.getText(this.sourceFile)}]'.`, node.expression.kind === ts.SyntaxKind.NumericLiteral
            ? [
                ymir_1.Replacement.append(node.expression.getStart(this.sourceFile), '('),
                ymir_1.Replacement.replace(node.expression.end, node.end, ').' + text),
            ]
            : ymir_1.Replacement.replace(node.expression.end, node.end, '.' + text));
    }
};
Rule = tslib_1.__decorate([
    ymir_1.excludeDeclarationFiles
], Rule);
exports.Rule = Rule;
//# sourceMappingURL=prefer-dot-notation.js.map