"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ymir_1 = require("@fimbul/ymir");
const ts = require("typescript");
let Rule = class Rule extends ymir_1.AbstractRule {
    apply() {
        return this.checkStatements(this.sourceFile);
    }
    checkStatements(block) {
        for (const statement of block.statements) {
            if (statement.kind !== ts.SyntaxKind.ModuleDeclaration)
                continue;
            if ((statement.flags & (ts.NodeFlags.Namespace | ts.NodeFlags.GlobalAugmentation)) === 0 &&
                statement.name.kind === ts.SyntaxKind.Identifier) {
                const end = statement.name.pos;
                const start = end - 'module'.length;
                this.addFinding(start, end, "Prefer 'namespace' over 'module'.", ymir_1.Replacement.replace(start, end, 'namespace'));
            }
            this.checkModule(statement);
        }
    }
    checkModule(node) {
        if (node.body === undefined)
            return;
        if (node.body.kind === ts.SyntaxKind.ModuleDeclaration)
            return this.checkModule(node.body);
        return this.checkStatements(node.body);
    }
};
Rule = tslib_1.__decorate([
    ymir_1.typescriptOnly
], Rule);
exports.Rule = Rule;
//# sourceMappingURL=prefer-namespace-keyword.js.map