"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ymir_1 = require("@fimbul/ymir");
class Rule extends ymir_1.AbstractRule {
    apply() {
        const sourceFile = this.sourceFile;
        const end = sourceFile.end;
        if (end === 0 || end === 1 && sourceFile.text[0] === '\uFEFF' || sourceFile.text[end - 1] === '\n')
            return;
        const lines = sourceFile.getLineStarts();
        this.addFinding(end, end, 'File must end with a newline.', ymir_1.Replacement.append(end, lines.length === 0 || sourceFile.text[lines[1] - 2] !== '\r' ? '\n' : '\r\n'));
    }
}
exports.Rule = Rule;
//# sourceMappingURL=trailing-newline.js.map