"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ymir_1 = require("@fimbul/ymir");
const ts = require("typescript");
const tsutils_1 = require("tsutils");
class Rule extends ymir_1.TypedRule {
    apply() {
        this.program.getSemanticDiagnostics(this.sourceFile).forEach(this.addDiagnostic, this);
        if (tsutils_1.isCompilerOptionEnabled(this.context.compilerOptions, 'declaration'))
            this.program.getDeclarationDiagnostics(this.sourceFile).forEach(this.addDiagnostic, this);
    }
    addDiagnostic(diagnostic) {
        const start = diagnostic.start;
        this.addFinding(start, start + diagnostic.length, ts.flattenDiagnosticMessageText(diagnostic.messageText, '\n'));
    }
}
exports.Rule = Rule;
//# sourceMappingURL=typecheck.js.map